#include <windows.h>
#include <stdlib.h>
#include <mmsystem.h>
#include <dos.h>
#define STATIC_WINDOW_NAME "Dimke Kuckucksuhr-Emulator"

#define TIMER_AKTUALISIERUNG 1
#define TIMER_AKTUALISIERUNG_MS 200

#define TIMER_KUCKUCK 2
#define TIMER_KUCKUCK_MS 1000

#define KUCKUCK_WAVE "kuckuck.wav"

#define WINDOW_CX 300
#define WINDOW_CY 45
#define WINDOW_X (GetSystemMetrics(SM_CXSCREEN) - WINDOW_CX) // Rechtsbndig
#define WINDOW_Y 0

LONG FAR PASCAL WndProc (HWND , UINT , UINT , LONG) ;
BOOL FAR PASCAL _export AboutDlgProc(HWND, UINT, UINT, LONG);
struct time zeit; int sek_alt;
char fenstertitel[100];

int PASCAL WinMain (HANDLE hInstance , HANDLE hPrevInstance , LPSTR lpszCmdParam , int nCmdShow){
	MSG msg ;
	HWND hwnd, hwnd_static;
	WNDCLASS wndclass, wndclass_hidden;
	if (!hPrevInstance){
		wndclass.style = CS_HREDRAW | CS_VREDRAW ;
		wndclass.lpfnWndProc = WndProc ;
		wndclass.cbClsExtra = 0 ;
		wndclass.cbWndExtra = 0 ;
		wndclass.hInstance = hInstance ;
		wndclass.hIcon = LoadIcon (hInstance, "CLOCK") ;
		wndclass.hCursor = LoadCursor (NULL , IDC_ARROW) ;
		wndclass.hbrBackground = GetStockObject (LTGRAY_BRUSH) ;
		wndclass.lpszMenuName = "MAINMENU" ;
		wndclass.lpszClassName = "WndClassName" ;
		RegisterClass (&wndclass) ; // Klasse fr Hauptfenster

		wndclass_hidden.style = 0;
		wndclass_hidden.lpfnWndProc = WndProc ;
		wndclass_hidden.cbClsExtra = 0 ;
		wndclass_hidden.cbWndExtra = 0 ;
		wndclass_hidden.hInstance = hInstance ;
		wndclass_hidden.hIcon = LoadIcon (NULL, IDI_APPLICATION) ;
		wndclass_hidden.hCursor = LoadCursor (NULL , IDC_ARROW) ;
		wndclass_hidden.hbrBackground = GetStockObject (LTGRAY_BRUSH) ;
		wndclass_hidden.lpszMenuName = NULL;
		wndclass_hidden.lpszClassName = "WndClassName_hidden" ;
		RegisterClass (&wndclass_hidden) ; // Klasse fr unsichtbares Fenster
	}

	if (FindWindow(NULL, STATIC_WINDOW_NAME)) {
		MessageBox(NULL, "Already one instance of this process running!", "Process already running!", MB_OK | MB_ICONSTOP);
		return(1);
	}

	hwnd_static = CreateWindow ("WndClassName_hidden",STATIC_WINDOW_NAME,WS_OVERLAPPEDWINDOW,0,0,0,0,
		NULL,NULL,hInstance,NULL);

	hwnd = CreateWindow ("WndClassName" ,  STATIC_WINDOW_NAME , WS_OVERLAPPEDWINDOW , WINDOW_X, WINDOW_Y ,
			WINDOW_CX, WINDOW_CY, NULL , NULL , hInstance , NULL) ;

	ShowWindow(hwnd , SW_SHOWMINIMIZED);
	UpdateWindow(hwnd);

	SetTimer(hwnd, TIMER_AKTUALISIERUNG, TIMER_AKTUALISIERUNG_MS, 0);

	while (GetMessage (&msg , NULL ,0 ,0)){
		TranslateMessage (&msg) ;
		DispatchMessage (&msg) ;
	}
	return msg.wParam ;
}

LONG FAR PASCAL WndProc (HWND hwnd , UINT message , UINT wParam , LONG lParam) {
static FARPROC lpfnAboutDlgProc;
static HANDLE  hInstance;
static BOOL viertel=FALSE, halb=FALSE, dreiviertel=FALSE, ganz=FALSE;
static int kuckuck_anzahl;

	switch (message){
		case WM_CREATE:
			hInstance = ((LPCREATESTRUCT) lParam)->hInstance;
			lpfnAboutDlgProc = MakeProcInstance ((FARPROC) AboutDlgProc, hInstance);
			return 0;

		case WM_COMMAND:
			if (wParam == 100) // Help => about
				DialogBox(hInstance, "ABOUT", hwnd, lpfnAboutDlgProc);

			if (wParam == 111) // Test Sound
				sndPlaySound(KUCKUCK_WAVE, SND_ASYNC);

			if (wParam == 110) // Exit
				SendMessage(hwnd, WM_CLOSE, 0, 0L);

			return 0;

		case WM_TIMER:	{
				if(wParam==TIMER_AKTUALISIERUNG){
					gettime(&zeit);
					if(zeit.ti_sec!=sek_alt){
						sek_alt=zeit.ti_sec;
						wsprintf(fenstertitel, "Aktuelle Uhrzeit: %02d:%02d:%02d",
							zeit.ti_hour, zeit.ti_min, zeit.ti_sec);
						SetWindowText(hwnd, fenstertitel);
						if(zeit.ti_min==15 && viertel==FALSE){ // Viertelstunde
							viertel=TRUE; ganz=FALSE;
							sndPlaySound(KUCKUCK_WAVE, SND_ASYNC);
							kuckuck_anzahl=0;
							SetTimer(hwnd, TIMER_KUCKUCK, TIMER_KUCKUCK_MS, 0);
						}
						if(zeit.ti_min==30 && halb==FALSE){ // Halbe Stunde
							halb=TRUE; viertel=FALSE;
							sndPlaySound(KUCKUCK_WAVE, SND_ASYNC);
							kuckuck_anzahl=1;
							SetTimer(hwnd, TIMER_KUCKUCK, TIMER_KUCKUCK_MS, 0);
						}
						if(zeit.ti_min==45 && dreiviertel==FALSE){ // Dreiviertel Stunde
							dreiviertel=TRUE; halb=FALSE;
							sndPlaySound(KUCKUCK_WAVE, SND_ASYNC);
							kuckuck_anzahl=2;
							SetTimer(hwnd, TIMER_KUCKUCK, TIMER_KUCKUCK_MS, 0);
						}
						if(zeit.ti_min==0 && ganz==FALSE){ // Ganze Stunde
							ganz=TRUE; dreiviertel=FALSE;
							sndPlaySound(KUCKUCK_WAVE, SND_ASYNC);
							kuckuck_anzahl=3;
							SetTimer(hwnd, TIMER_KUCKUCK, TIMER_KUCKUCK_MS, 0);
						}
					}
				}

				if(wParam==TIMER_KUCKUCK){
					if(kuckuck_anzahl>0){
						kuckuck_anzahl--;
						sndPlaySound(KUCKUCK_WAVE, SND_ASYNC);
					}
					else {
						KillTimer(hwnd, TIMER_KUCKUCK);
					}
				}

				break;

		case WM_CLOSE:
				KillTimer(hwnd, TIMER_AKTUALISIERUNG);
				KillTimer(hwnd, TIMER_KUCKUCK);
				PostQuitMessage(0);

		return 0 ;
		}
	}
	return DefWindowProc (hwnd , message , wParam , lParam) ;
}

BOOL FAR PASCAL _export AboutDlgProc (HWND hDlg, UINT message, UINT wParam, LONG lParam) {
	switch(message) {
		case WM_INITDIALOG:
			return TRUE;

		case WM_COMMAND:
			switch(wParam) {
				case IDOK:
				case IDCANCEL:
					EndDialog(hDlg, 0);
					return TRUE;
			}
			break;
	}
	return FALSE;
}
